using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace ClothesMod
{
    public class ClothesMod
    {
        public static void Main()
        {

          CategoryBuilder.Create("Trousers", "There are different types of trousers and shorts here.", ModAPI.LoadSprite("CategoryIcons/TrousersСategory.png"));
          CategoryBuilder.Create("Hats", "There are different types of hats here.", ModAPI.LoadSprite("CategoryIcons/HatsCategory.png"));
          CategoryBuilder.Create("Costumes", "There are T-shirts, shirts, suits of a policeman, a fireman,a cook, and so on here.", ModAPI.LoadSprite("CategoryIcons/CostumesCategory.png"));
          CategoryBuilder.Create("Others", "There are different types of hair,beards here.", ModAPI.LoadSprite("CategoryIcons/OthersCategory.png"));

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Red T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RedT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/RedT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/RedT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/RedT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/RedT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Blue T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlueT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlueT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/BlueT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/BlueT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/BlueT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Yellow T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/YellowT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/YellowT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/YellowT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/YellowT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/YellowT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Purple T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PurpleT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PurpleT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/PurpleT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/PurpleT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/PurpleT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/PurpleT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Orange T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/OrangeT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/OrangeT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/OrangeT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/OrangeT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/OrangeT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/OrangeT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Gray T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/GrayT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GrayT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/GrayT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/GrayT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/GrayT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/GrayT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Green T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/GreenT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GreenT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/GreenT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/GreenT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/GreenT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/GreenT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Cyan T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/CyanT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/CyanT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/CyanT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/CyanT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/CyanT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/CyanT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "White T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WhiteT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WhiteT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/WhiteT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/WhiteT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/WhiteT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/WhiteT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Turquoise T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/TurquoiseT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurquoiseT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/TurquoiseT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/TurquoiseT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/TurquoiseT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/TurquoiseT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black T-shirt", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlackT-shirtIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackT-shirt1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackT-shirt1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/BlackT-shirt2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/BlackT-shirt3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/BlackT-shirt4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Jacket", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlackJacketIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackJacket1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 5;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackJacket1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/BlackJacket2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/BlackJacket3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/BlackJacket4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/BlackJacket5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Blue Jacket", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlueJacketIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueJacket1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 5;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlueJacket1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/BlueJacket2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/BlueJacket3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/BlueJacket4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/BlueJacket5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Yellow Jacket", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/YellowJacketIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowJacket1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 5;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/YellowJacket1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/YellowJacket2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/YellowJacket3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/YellowJacket4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/YellowJacket5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Red Jacket", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RedJacketIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedJacket1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 5;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/RedJacket1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/RedJacket2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/RedJacket3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/RedJacket4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/RedJacket5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "White Jacket", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/WhiteJacketIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WhiteJacket1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 5;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/WhiteJacket1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/WhiteJacket2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/WhiteJacket3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/WhiteJacket4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/WhiteJacket5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Trousers", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Trousers"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlackTrousersIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackTrousers3.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackTrousers1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/BlackTrousers2.png";
                        armProp[0].armorPiece = "UpperLeg";
                        armProp[0].clone = true;
                        armProp[0].armorTier = 4;

                        armProp[1].sprite = "Textures/BlackTrousers3.png";
                        armProp[1].armorPiece = "LowerLeg";
                        armProp[1].clone = true;
                        armProp[1].armorTier = 4;

                        armProp[2].sprite = "Textures/BlackTrousers4.png";
                        armProp[2].armorPiece = "Foot";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Trousers", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Trousers"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BrownTrousersIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownTrousers3.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 4;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "LowerBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownTrousers1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/BrownTrousers2.png";
                        armProp[0].armorPiece = "UpperLeg";
                        armProp[0].clone = true;
                        armProp[0].armorTier = 4;

                        armProp[1].sprite = "Textures/BrownTrousers3.png";
                        armProp[1].armorPiece = "LowerLeg";
                        armProp[1].clone = true;
                        armProp[1].armorTier = 4;

                        armProp[2].sprite = "Textures/BrownTrousers4.png";
                        armProp[2].armorPiece = "Foot";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Police Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PoliceUniformIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PoliceUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 6;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/PoliceUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/PoliceUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/PoliceUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/PoliceUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/PoliceUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/PoliceUniform6.png";
                        armProp[4].armorPiece = "Head";
                        armProp[4].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Prisoner Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/PrisonerUniformIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PrisonerUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 7;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/PrisonerUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/PrisonerUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/PrisonerUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/PrisonerUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/PrisonerUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/PrisonerUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/PrisonerUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Grass Soldier Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/GrassSoldierUniformIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GrassSoldierUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/GrassSoldierUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/GrassSoldierUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/GrassSoldierUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/GrassSoldierUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/GrassSoldierUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/GrassSoldierUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/GrassSoldierUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/GrassSoldierUniform8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/GrassSoldierUniform9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Sand Soldier Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/SandSoldierUniformIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SandSoldierUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/SandSoldierUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/SandSoldierUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/SandSoldierUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/SandSoldierUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/SandSoldierUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/SandSoldierUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/SandSoldierUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/SandSoldierUniform8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/SandSoldierUniform9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Firefighter Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/FirefighterUniformIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FirefighterUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/FirefighterUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/FirefighterUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/FirefighterUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/FirefighterUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/FirefighterUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/FirefighterUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/FirefighterUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/FirefighterUniform8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/FirefighterUniform9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"), 
                    NameOverride = "Android Costume", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/AndroidCostumeIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/AndroidCostume1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/AndroidCostume1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/AndroidCostume2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/AndroidCostume3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/AndroidCostume4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/AndroidCostume5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/AndroidCostume6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/AndroidCostume7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/AndroidCostume8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/AndroidCostume9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Chef Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/ChefUniformIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ChefUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 6;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/ChefUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/ChefUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/ChefUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/ChefUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/ChefUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/ChefUniform6.png";
                        armProp[4].armorPiece = "Head";
                        armProp[4].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Hazmat Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HazmatUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 10;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/HazmatUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/HazmatUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/HazmatUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/HazmatUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/HazmatUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/HazmatUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/HazmatUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/HazmatUniform8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/HazmatUniform9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        armProp[8].sprite = "Textures/HazmatUniform10.png";
                        armProp[8].armorPiece = "Head";
                        armProp[8].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Construction Worker Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ConstructionWorkerUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/ConstructionWorkerUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/ConstructionWorkerUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/ConstructionWorkerUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/ConstructionWorkerUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/ConstructionWorkerUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/ConstructionWorkerUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/ConstructionWorkerUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/ConstructionWorkerUniform8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/ConstructionWorkerUniform9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "SWAT Uniform", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Costumes"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SWATUniform1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 9;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/SWATUniform1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].sprite = "Textures/SWATUniform2.png";
                        armProp[0].armorTier = 4;
                        armProp[0].armorPiece = "MiddleBody";

                        armProp[1].sprite = "Textures/SWATUniform3.png";
                        armProp[1].armorTier = 4;
                        armProp[1].armorPiece = "LowerBody";

                        armProp[2].sprite = "Textures/SWATUniform4.png";
                        armProp[2].armorPiece = "UpperArm";
                        armProp[2].clone = true;
                        armProp[2].armorTier = 4;

                        armProp[3].sprite = "Textures/SWATUniform5.png";
                        armProp[3].armorPiece = "LowerArm";
                        armProp[3].clone = true;
                        armProp[3].armorTier = 4;

                        armProp[4].sprite = "Textures/SWATUniform6.png";
                        armProp[4].armorPiece = "UpperLeg";
                        armProp[4].clone = true;
                        armProp[4].armorTier = 4;

                        armProp[5].sprite = "Textures/SWATUniform7.png";
                        armProp[5].armorPiece = "LowerLeg";
                        armProp[5].clone = true;
                        armProp[5].armorTier = 4;

                        armProp[6].sprite = "Textures/SWATUniform8.png";
                        armProp[6].armorPiece = "Foot";
                        armProp[6].clone = true;
                        armProp[6].armorTier = 4;

                        armProp[7].sprite = "Textures/SWATUniform9.png";
                        armProp[7].armorPiece = "Head";
                        armProp[7].armorTier = 4;

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Mafia Hat", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Hats"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/MafiaHatIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/MafiaHat.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/MafiaHat.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Don Hat", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Hats"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/DonHatIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/DonHat.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/DonHat.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Blue Cap", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Hats"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/BlueCapIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlueCap.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlueCap.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Red Cap", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Hats"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/RedCapIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RedCap.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/RedCap.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Yellow Cap", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Hats"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/YellowCapIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/YellowCap.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/YellowCap.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Glasses", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Hats"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/GlassesIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Glasses.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/Glasses.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Moustache", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownMoustache.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownMoustache.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Hair Variant 1", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownHair1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownHair1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Hair Variant 2", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownHair2.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownHair2.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Hair Variant 3", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownHair3.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownHair3.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Hair Variant 4", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownHair4.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownHair4.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Hair Variant 5", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownHair5.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownHair5.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Long Hair", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownLongHair.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownLongHair.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Beard Variant 1", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownBeard1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownBeard1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Beard Variant 2", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownBeard2.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownBeard2.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Brown Beard Variant 3", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BrownBeard3.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BrownBeard3.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Moustache", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackMoustache.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackMoustache.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Hair Variant 1", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackHair1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackHair1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Hair Variant 2", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackHair2.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackHair2.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Hair Variant 3", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackHair3.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackHair3.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Hair Variant 4", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackHair4.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackHair4.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Hair Variant 5", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackHair5.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackHair5.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Long Hair", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackLongHair.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackLongHair.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Beard Variant 1", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackBeard1.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackBeard1.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Beard Variant 2", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackBeard2.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackBeard2.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Plank"), 
                    NameOverride = "Black Beard Variant 3", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("Others"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Icons/NoIcon.png"), 
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BlackBeard3.png"); 
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        int PartCount = 1;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 4;
                        prop.sprite = "Textures/BlackBeard3.png";

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
                    }
                }
            );
        }
    }
}